import 'dart:io';

import 'package:path_provider/path_provider.dart';

import '../models/classes.dart';
import '../utils/utils.dart';

class LogFile {
  LoggerConfig _config;
  LogFile._();

  static final LogFile _singleton = LogFile._();

  static LogFile getInstance(LoggerConfig config) {
    _singleton._config = config;
    return _singleton;
  }

  Future<String> readLog() async {
    try {
      final file = await _file;
      return file.readAsString();
    } catch (err) {
      throw err;
    }
  }

  Future writeLog(String log) async {
    try {
      final file = await _file;
      IOSink skin = file.openWrite(mode: FileMode.append);
      skin.write(log + "\n");
      skin.close();
    } catch (err) {
      throw err;
    }
  }

  Future<String> get _appPath async {
    Directory directory = await getApplicationDocumentsDirectory();
    return directory.path;
  }

  Future<File> get _file async {
    final path = await _appPath + "/" + _config.fileDirectoryName;

    await Directory(path).create();
    String fileName = LoggerUtils.getCurrentDateString();
    File file = File("$path/$fileName.log");

    return file;
  }
}
