import '../models/classes.dart';
import '../models/constants.dart';
import '../models/enums.dart';

class LoggerConfigImpl implements LoggerConfig {
  LoggerLevel printLevel = Constants.defaultPrintLevel;
  LoggerLevel fileLevel = Constants.defaultFileLevel;
  String fileDirectoryName = Constants.defaultFileDirectoryName;
  LoggerLevel serverLevel = Constants.defaultServerLevel;
  String serverUrl = Constants.defaultServerUrl;

  LoggerConfigImpl._();
  static final LoggerConfigImpl _singleton = LoggerConfigImpl._();
  static LoggerConfig get instance => _singleton;

  updateConfig({
    LoggerLevel printLevel,
    LoggerLevel fileLevel,
    String fileDirectoryName,
    LoggerLevel serverLevel,
    String serverUrl,
  }) {
    if (printLevel != null) this.printLevel = printLevel;
    if (fileLevel != null) this.fileLevel = fileLevel;
    if (fileDirectoryName != null) this.fileDirectoryName = fileDirectoryName;
    if (serverLevel != null) this.serverLevel = serverLevel;
    if (serverUrl != null) this.serverUrl = serverUrl;
  }
}
